/* THIS FILE, Tables.SQL, WAS USED TO GENERATE THE IBDEMOS.GDB METADATA */



/* Create the database itself */

CREATE DATABASE "c:\General\Interbase\Data\IBDemos.gdb" PAGE_SIZE 1024 
;


/* Create the tables */


/* Table: ANIMALS, Owner: SYSDBA */
CREATE TABLE ANIMALS (NAME VARCHAR(10),
        SIZ_ SMALLINT,
        WEIGHT SMALLINT,
        AREA VARCHAR(20),
        BMP BLOB SUB_TYPE 0 SEGMENT SIZE 80);

/* Table: BIOLIFE, Owner: SYSDBA */
CREATE TABLE BIOLIFE (SPECIES_NO DOUBLE PRECISION,
        CATEGORY VARCHAR(15),
        COMMON_NAME VARCHAR(30),
        SPECIES_NAME VARCHAR(40),
        LENGTH__CM_ DOUBLE PRECISION,
        LENGTH_IN DOUBLE PRECISION,
        NOTES BLOB SUB_TYPE TEXT SEGMENT SIZE 80,
        GRAPHIC BLOB SUB_TYPE 0 SEGMENT SIZE 80);

/* Table: CLIENTS, Owner: SYSDBA */
CREATE TABLE CLIENTS (LAST_NAME VARCHAR(20),
        FIRST_NAME VARCHAR(20),
        ACCT_NBR DOUBLE PRECISION,
        ADDRESS_1 VARCHAR(20),
        CITY VARCHAR(20),
        STATE VARCHAR(2),
        ZIP VARCHAR(5),
        TELEPHONE VARCHAR(12),
        DATE_OPEN DATE,
        SS_NUMBER DOUBLE PRECISION,
        PICTURE VARCHAR(15),
        BIRTH_DATE DATE,
        RISK_LEVEL VARCHAR(8),
        OCCUPATION VARCHAR(20),
        OBJECTIVES VARCHAR(10),
        INTERESTS VARCHAR(120),
        IMAGE BLOB SUB_TYPE 0 SEGMENT SIZE 80);

/* Table: COUNTRY, Owner: SYSDBA */
CREATE TABLE COUNTRY (NAME VARCHAR(24),
        CAPITAL VARCHAR(24),
        CONTINENT VARCHAR(24),
        AREA DOUBLE PRECISION,
        POPULATION DOUBLE PRECISION);

/* Table: CUSTOLY, Owner: SYSDBA */
CREATE TABLE CUSTOLY (CUSTNO INTEGER,
        LAST_NAME VARCHAR(30),
        FIRST_NAME VARCHAR(30),
        VIP_STATUS VARCHAR(10),
        ADDRESS1 VARCHAR(40),
        ADDRESS2 VARCHAR(40),
        CITY VARCHAR(20),
        STATE_PROV VARCHAR(10),
        POST_CODE VARCHAR(10),
        COUNTRY VARCHAR(10),
        PHONE VARCHAR(18),
        FAX VARCHAR(18),
        EMAIL VARCHAR(40),
        REMARKS BLOB SUB_TYPE TEXT SEGMENT SIZE 80);

/* Table: CUSTOMER, Owner: SYSDBA */
CREATE TABLE CUSTOMER (CUSTNO DOUBLE PRECISION NOT NULL,
        COMPANY VARCHAR(30),
        ADDR1 VARCHAR(30),
        ADDR2 VARCHAR(30),
        CITY VARCHAR(15),
        STATE VARCHAR(20),
        ZIP VARCHAR(10),
        COUNTRY VARCHAR(20),
        PHONE VARCHAR(15),
        FAX VARCHAR(15),
        TAXRATE DOUBLE PRECISION,
        CONTACT VARCHAR(20),
        LASTINVOICEDATE DATE,
PRIMARY KEY (CUSTNO));

/* Table: EMPLOYEE, Owner: SYSDBA */
CREATE TABLE EMPLOYEE (EMPNO INTEGER,
        LASTNAME VARCHAR(20),
        FIRSTNAME VARCHAR(15),
        PHONEEXT VARCHAR(4),
        HIREDATE DATE,
        SALARY DOUBLE PRECISION);

/* Table: EVENTS, Owner: SYSDBA */
CREATE TABLE EVENTS (EVENTNO INTEGER,
        VENUENO INTEGER,
        EVENT_NAME VARCHAR(30),
        EVENT_DATE DATE,
        EVENT_TIME DATE,
        EVENT_DESCRIPTION BLOB SUB_TYPE TEXT SEGMENT SIZE 80,
        TICKET_PRICE DOUBLE PRECISION,
        EVENT_PHOTO BLOB SUB_TYPE 0 SEGMENT SIZE 80);

/* Table: HOLDINGS, Owner: SYSDBA */
CREATE TABLE HOLDINGS (ACCT_NBR DOUBLE PRECISION,
        SYMBOL VARCHAR(7),
        SHARES DOUBLE PRECISION,
        PUR_PRICE DOUBLE PRECISION,
        PUR_DATE DATE);

/* Table: INDUSTRY, Owner: SYSDBA */
CREATE TABLE INDUSTRY (IND_CODE SMALLINT,
        IND_NAME VARCHAR(5),
        LONG_NAME VARCHAR(20));

/* Table: ITEMS, Owner: SYSDBA */
CREATE TABLE ITEMS (ORDERNO DOUBLE PRECISION,
        ITEMNO DOUBLE PRECISION,
        PARTNO DOUBLE PRECISION,
        QTY INTEGER,
        DISCOUNT DOUBLE PRECISION);

/* Table: MASTER, Owner: SYSDBA */
CREATE TABLE MASTER (SYMBOL VARCHAR(7),
        CO_NAME VARCHAR(20),
        EXCHANGE VARCHAR(8),
        CUR_PRICE DOUBLE PRECISION,
        YRL_HIGH DOUBLE PRECISION,
        YRL_LOW DOUBLE PRECISION,
        P_E_RATIO DOUBLE PRECISION,
        BETA DOUBLE PRECISION,
        PROJ_GRTH DOUBLE PRECISION,
        INDUSTRY SMALLINT,
        PRICE_CHG SMALLINT,
        SAFETY SMALLINT,
        RATING VARCHAR(4),
        RANK DOUBLE PRECISION,
        OUTLOOK SMALLINT,
        RCMNDATION VARCHAR(5),
        RISK VARCHAR(4));

/* Table: NEXTCUST, Owner: SYSDBA */
CREATE TABLE NEXTCUST (NEWCUST DOUBLE PRECISION);

/* Table: NEXTITEM, Owner: SYSDBA */
CREATE TABLE NEXTITEM (NEWKEY DOUBLE PRECISION);

/* Table: NEXTORD, Owner: SYSDBA */
CREATE TABLE NEXTORD (NEWKEY DOUBLE PRECISION);

/* Table: ORDERS, Owner: SYSDBA */
CREATE TABLE ORDERS (ORDERNO DOUBLE PRECISION NOT NULL,
        CUSTNO DOUBLE PRECISION NOT NULL,
        SALEDATE DATE,
        SHIPDATE DATE,
        EMPNO INTEGER NOT NULL,
        SHIPTOCONTACT VARCHAR(20),
        SHIPTOADDR1 VARCHAR(30),
        SHIPTOADDR2 VARCHAR(30),
        SHIPTOCITY VARCHAR(15),
        SHIPTOSTATE VARCHAR(20),
        SHIPTOZIP VARCHAR(10),
        SHIPTOCOUNTRY VARCHAR(20),
        SHIPTOPHONE VARCHAR(15),
        SHIPVIA VARCHAR(7),
        PO VARCHAR(15),
        TERMS VARCHAR(6),
        PAYMENTMETHOD VARCHAR(7),
        ITEMSTOTAL DOUBLE PRECISION,
        TAXRATE DOUBLE PRECISION,
        FREIGHT DOUBLE PRECISION,
        AMOUNTPAID DOUBLE PRECISION,
PRIMARY KEY (ORDERNO));

/* Table: PARTS, Owner: SYSDBA */
CREATE TABLE PARTS (PARTNO DOUBLE PRECISION NOT NULL,
        VENDORNO DOUBLE PRECISION,
        DESCRIPTION VARCHAR(30),
        ONHAND DOUBLE PRECISION,
        ONORDER DOUBLE PRECISION,
        COST DOUBLE PRECISION,
        LISTPRICE DOUBLE PRECISION,
PRIMARY KEY (PARTNO));

/* Table: RESERVAT, Owner: SYSDBA */
CREATE TABLE RESERVAT (RESNO INTEGER,
        EVENTNO INTEGER,
        CUSTNO INTEGER,
        NUMTICKETS INTEGER,
        AMT_PAID DOUBLE PRECISION,
        PAY_METHOD VARCHAR(10),
        CARD_NO VARCHAR(20),
        CARD_EXP DATE,
        PAY_NOTES BLOB SUB_TYPE TEXT SEGMENT SIZE 80,
        PURGE_DATE DATE,
        PAID VARCHAR(1));

/* Table: VENDORS, Owner: SYSDBA */
CREATE TABLE VENDORS (VENDORNO DOUBLE PRECISION NOT NULL,
        VENDORNAME VARCHAR(30),
        ADDRESS1 VARCHAR(30),
        ADDRESS2 VARCHAR(30),
        CITY VARCHAR(20),
        STATE VARCHAR(20),
        ZIP VARCHAR(10),
        COUNTRY VARCHAR(15),
        PHONE VARCHAR(15),
        FAX VARCHAR(15),
        PREFERRED VARCHAR(1),
PRIMARY KEY (VENDORNO));

/* Table: VENUES, Owner: SYSDBA */
CREATE TABLE VENUES (VENUENO INTEGER,
        VENUE VARCHAR(30),
        CAPACITY INTEGER,
        VENUE_MAP BLOB SUB_TYPE 0 SEGMENT SIZE 80,
        REMARKS BLOB SUB_TYPE TEXT SEGMENT SIZE 80);

/*  Create Indexes */
CREATE INDEX NAME ON ANIMALS(NAME);
CREATE UNIQUE INDEX BIOLIFE0 ON BIOLIFE(SPECIES_NO);
CREATE UNIQUE INDEX COUNTRY0 ON COUNTRY(NAME);
CREATE INDEX CITY ON CUSTOLY(CITY);
CREATE UNIQUE INDEX CUSTOLY0 ON CUSTOLY(CUSTNO);
CREATE INDEX BYCOMPANY ON CUSTOMER(COMPANY);
CREATE UNIQUE INDEX CUSTOMER0 ON CUSTOMER(CUSTNO);
CREATE INDEX BYNAME ON EMPLOYEE(LASTNAME, FIRSTNAME);
CREATE UNIQUE INDEX EMPLOYEE0 ON EMPLOYEE(EMPNO);
CREATE INDEX DATE_TIME ON EVENTS(EVENT_NAME, EVENT_DATE);
CREATE UNIQUE INDEX EVENTS0 ON EVENTS(EVENTNO);
CREATE INDEX ACCT_NBR ON HOLDINGS(ACCT_NBR);
CREATE INDEX SYMBOL ON HOLDINGS(SYMBOL);
CREATE INDEX IND_CODE ON INDUSTRY(IND_CODE);
CREATE INDEX BYORDERNO ON ITEMS(ORDERNO);
CREATE UNIQUE INDEX ITEMS0 ON ITEMS(ORDERNO, ITEMNO);
CREATE INDEX PARTNO ON ITEMS(PARTNO);
CREATE INDEX GROWTHASC ON MASTER(PROJ_GRTH);
CREATE DESCENDING INDEX GROWTHDESC ON MASTER(PROJ_GRTH);
CREATE INDEX CUSTNO ON ORDERS(CUSTNO);
CREATE UNIQUE INDEX ORDERS0 ON ORDERS(ORDERNO);
CREATE INDEX BYDESCRIPTION ON PARTS(DESCRIPTION);
CREATE UNIQUE INDEX PARTS0 ON PARTS(PARTNO);
CREATE INDEX VENDORNO ON PARTS(VENDORNO);
CREATE INDEX EVENTNO ON RESERVAT(EVENTNO);
CREATE UNIQUE INDEX RESERVAT0 ON RESERVAT(RESNO);
CREATE UNIQUE INDEX VENDORS0 ON VENDORS(VENDORNO);
CREATE UNIQUE INDEX VENUES0 ON VENUES(VENUENO);


/* Add foreign keys once the entire table structure */
/* set up and approved                              */

ALTER TABLE ITEMS ADD FOREIGN KEY (ORDERNO) REFERENCES ORDERS(ORDERNO);
ALTER TABLE ITEMS ADD FOREIGN KEY (PARTNO) REFERENCES PARTS(PARTNO);
ALTER TABLE ORDERS ADD FOREIGN KEY (CUSTNO) REFERENCES CUSTOMER(CUSTNO);
ALTER TABLE PARTS ADD FOREIGN KEY (VENDORNO) REFERENCES VENDORS(VENDORNO);


COMMIT;
